"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useFetch = useFetch;

var _usePromise = require("./usePromise");

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function useFetch(path, options) {
  var defaultFormatter = function defaultFormatter(response) {
    return response.json();
  };

  var fetchInstance = function fetchInstance(formatter) {
    return function (path, options) {
      return fetch(path, options).then(typeof formatter === "function" && formatter || defaultFormatter);
    };
  };

  if (options) {
    var formatter = options.formatter,
        fetchOptions = _objectWithoutProperties(options, ["formatter"]);

    return (0, _usePromise.usePromise)(fetchInstance(formatter), path, fetchOptions);
  } else {
    return (0, _usePromise.usePromise)(fetchInstance(), path);
  }
}