"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePromise = usePromise;
exports.flattenInput = void 0;

var _react = require("react");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var flattenInput = function flattenInput() {
  for (var _len = arguments.length, inputs = new Array(_len), _key = 0; _key < _len; _key++) {
    inputs[_key] = arguments[_key];
  }

  return inputs.reduce(function (accumulator, input) {
    if (input instanceof Array) {
      return [].concat(_toConsumableArray(accumulator), _toConsumableArray(flattenInput.apply(void 0, _toConsumableArray(input))));
    }

    if (input instanceof Object) {
      var keys = Object.keys(input);
      return [].concat(_toConsumableArray(accumulator), _toConsumableArray(flattenInput.apply(void 0, _toConsumableArray(keys.reduce(function (a, k) {
        return [].concat(_toConsumableArray(a), [k, input[k]]);
      }, [])))));
    }

    return [].concat(_toConsumableArray(accumulator), [input]);
  }, []);
};

exports.flattenInput = flattenInput;

function usePromise(callFunction) {
  for (var _len2 = arguments.length, inputs = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    inputs[_key2 - 1] = arguments[_key2];
  }

  var _useState = (0, _react.useState)(null),
      _useState2 = _slicedToArray(_useState, 2),
      data = _useState2[0],
      setData = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isLoading = _useState4[0],
      setLoading = _useState4[1];

  var _useState5 = (0, _react.useState)(),
      _useState6 = _slicedToArray(_useState5, 2),
      error = _useState6[0],
      setError = _useState6[1];

  var call = function call() {
    if (!callFunction) {
      return;
    }

    setLoading(true);
    callFunction.apply(void 0, inputs).then(function (data) {
      setData(data);
      setLoading(false);
    }).catch(function (error) {
      setError(error);
      setLoading(false);
    });
  };

  (0, _react.useEffect)(call, _toConsumableArray(flattenInput(inputs)));
  return {
    data: data,
    isLoading: isLoading,
    error: error
  };
}